%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Definitions of builtins of module Directory:
%

:- use_module(library(system)).

?- block prim_doesFileExist(?,?,?,-,?).
prim_doesFileExist(RFileName,_,'$io'(Exists),E0,E) :-
	derefAll(RFileName,FileName),
	string2Atom(FileName,FName),
	((file_exists(FName), file_property(FName,type(regular)))
	 -> Exists='True'
	  ; Exists='False'), E0=E.

?- block prim_doesDirectoryExist(?,?,?,-,?).
prim_doesDirectoryExist(RDirName,_,'$io'(Exists),E0,E) :-
	derefAll(RDirName,DirName),
	string2Atom(DirName,Dir),
	((file_exists(Dir), file_property(Dir,type(directory)))
	 -> Exists='True'
	  ; Exists='False'), E0=E.

?- block prim_getModificationTime(?,?,?,-,?).
prim_getModificationTime(RFileName,_,'$io'(Time),E0,E) :-
	derefAll(RFileName,FileName),
	string2Atom(FileName,FName),
	file_property(FName,mod_time(Time)), E0=E.

?- block prim_fileSize(?,?,?,-,?).
prim_fileSize(RFileName,_,'$io'(Size),E0,E) :-
	derefAll(RFileName,FileName),
	string2Atom(FileName,FName),
	file_property(FName,size(Size)), E0=E.

?- block prim_getDirectoryContents(?,?,?,-,?).
prim_getDirectoryContents(RDirName,_,'$io'(EntryNames),E0,E) :-
	derefAll(RDirName,DirName),
	string2Atom(DirName,Dir),
	directory_files(Dir,Entries),
	map2(atom2String,Entries,EntryNames), E0=E.
