-- A simple program implementing the kernel of the Unix "talk"
-- to enable a conversation between two partners on different machines

import Ports

-- Message to inform the partner to show a string:
data TalkMsg = Talk String

-- start the talk between your_port and my_port
talk :: String -> String -> IO ()
talk my_port your_port = do
  incoming   <- openNamedPort my_port
  ttyport    <- openStdInOutPort
  putStrLn ("Waiting for connection to '"++your_port++"'")
  Just targetPort <- waitAndConnectPort 1000 (putChar '.') (-1) your_port
  putStrLn ("Connected to '"++your_port++"'")
  talkloop targetPort ttyport incoming (choiceSPEP ttyport incoming)

-- the main loop to implement the conversation:
talkloop :: Port TalkMsg -> Port SP_Msg -> [TalkMsg]
                                        -> Either String [TalkMsg] -> IO ()
talkloop port ttyport _ (Right (Talk msg:msgs)) =
  if msg=="." then done
              else putStrLn ('*':msg) >>
                   talkloop port ttyport msgs (choiceSPEP ttyport msgs)
talkloop port ttyport msgs (Left ttyline) =
  doSend (Talk ttyline) port >>
  if ttyline=="." then done
                  else talkloop port ttyport msgs (choiceSPEP ttyport msgs)


-- start "talk1" on one machine:
talk1 = talk "me" "you" --"you@sauron.informatik.uni-kiel.de"

-- start "talk2" on another machine:
talk2 = talk "you" "me" --"me@petrus.informatik.uni-kiel.de"
