--- Library for accessing the directory structure of the
--- underlying operating system.
---
--- @author Michael Hanus
--- @version January 2004

module Directory(doesFileExist,doesDirectoryExist,fileSize,
                 getModificationTime,getDirectoryContents) where


--- Returns true if the argument is the name of an existing file.
doesFileExist :: String -> IO Bool
doesFileExist fname = seq (groundNormalForm fname) (prim_doesFileExist fname)

prim_doesFileExist :: String -> IO Bool
prim_doesFileExist external

--- Returns true if the argument is the name of an existing directory.
doesDirectoryExist :: String -> IO Bool
doesDirectoryExist dir = seq (groundNormalForm dir) (prim_doesDirectoryExist dir)

prim_doesDirectoryExist :: String -> IO Bool
prim_doesDirectoryExist external

--- Returns the size of the file.
fileSize :: String -> IO Int
fileSize fname = seq (groundNormalForm fname) (prim_fileSize fname)

prim_fileSize :: String -> IO Int
prim_fileSize external

--- Returns the modification time of the file.
getModificationTime :: String -> IO Int
getModificationTime fname = seq (groundNormalForm fname) (prim_getModificationTime fname)

prim_getModificationTime :: String -> IO Int
prim_getModificationTime external

--- Returns the list of all entries in a directory.
getDirectoryContents :: String -> IO [String]
getDirectoryContents dir = seq (groundNormalForm dir) (prim_getDirectoryContents dir)

prim_getDirectoryContents :: String -> IO [String]
prim_getDirectoryContents external

